﻿using UnityEngine;
using System.Collections;

public class MiniPlayer : MonoBehaviour {

    public IEnumerator StandCR()
    {
        GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeRotation;

        float t = 0;

        while(Mathf.Abs(transform.localEulerAngles.z) > 5)
        {
            t += Time.deltaTime/10f;
            transform.rotation = Quaternion.Lerp(transform.rotation, Quaternion.identity, t);
            yield return null;
        }

        transform.rotation = Quaternion.identity;
    }

    public IEnumerator MoveTo(Vector3 moveTo)
    {
        float t = 0;
        while (Mathf.Abs(transform.localPosition.x - moveTo.x) > 0.9f)
        {
            t += Time.deltaTime / 15;
            GetComponent<Rigidbody2D>().MovePosition(Vector3.Lerp(transform.localPosition, moveTo, t));
            yield return null;
        }

    }

}
