﻿using UnityEngine;
using System.Collections;

public class Vine : MonoBehaviour {

    public float hp = 50;
    public float burnRate = 5;

    public GameObject vine1;
    public GameObject vine2;
    public GameObject vine3;

    private VineState vineState = VineState.INTACT;

    private enum VineState
    {
        INTACT,
        SEMI_INTACT,
        DESTROYED
    }

    void OnTriggerStay2D(Collider2D col)
    {
        if(col.tag == "Burner")
        {
            hp -= Time.deltaTime * burnRate;

            switch(vineState)
            {
                case VineState.INTACT:
                    if(hp <= 25)
                    {
                        vineState = VineState.SEMI_INTACT;
                        vine1.gameObject.SetActive(false);
                        vine2.gameObject.SetActive(true);
                    }
                    break;

                case VineState.SEMI_INTACT:
                    if (hp <= 0)
                    {
                        SoundManager.PlaySFX("vine");
                        vineState = VineState.DESTROYED;
                        vine2.gameObject.SetActive(false);
                        vine3.gameObject.SetActive(true);
                        GetComponent<Collider2D>().enabled = false;
                    }
                    break;

            }
        }
    }
}
