﻿using UnityEngine;
using System.Collections;
using Com.LuisPedroFonseca.ProCamera2D;

public class Wall : MonoBehaviour {

    public float endurance = 5;
    public GameObject wall1;
    public GameObject wall2;
    public GameObject wall3;
    public GameObject wall4;

    private WallState wallState = WallState.INTACT;

    private enum WallState
    {
        INTACT,
        SEMI_INTACT,
        SEMI_DESTROYED,
        DESTROYED
    }

    void OnCollisionEnter2D(Collision2D col)
    {
        if(Mathf.Abs(col.relativeVelocity.x) > endurance)
        {
            switch(wallState)
            {
                case WallState.INTACT:
                    SoundManager.PlaySFX("doorBreak");
                    ProCamera2DShake.Instance.ShakeUsingPreset("Fall");
                    wallState = WallState.SEMI_INTACT;
                    wall1.SetActive(false);
                    wall2.SetActive(true);
                    break;
                case WallState.SEMI_INTACT:
                    SoundManager.PlaySFX("doorBreak");
                    ProCamera2DShake.Instance.ShakeUsingPreset("Fall");
                    wallState = WallState.SEMI_DESTROYED;
                    wall2.SetActive(false);
                    wall3.SetActive(true);
                    StartCoroutine("AnimateWall");
                    break;
                case WallState.SEMI_DESTROYED:
                    break;
                case WallState.DESTROYED:
                    break;
            }
        } else
        {
            SoundManager.PlaySFX("doorTouch");
        }
    }

    IEnumerator AnimateWall()
    {
        yield return new WaitForSeconds(0.3f);
        wallState = WallState.DESTROYED;
        wall3.SetActive(false);
        wall4.SetActive(true);
        GetComponent<Collider2D>().enabled = false;
        enabled = false;
    }
}
